   title   DD_Basic - Siekmanski 2006
     .686p 
      .model flat, C, stdcall 
       option casemap :none 
      .xmm 

   include windows.inc
   include kernel32.inc
   include user32.inc
   include ole32.inc
   include oleaut32.inc
   include winmm.inc
   include gdi32.inc

   include ..\include\sse3_macros.inc
   include ..\include\dxmacros.inc
   include ..\include\ddraw.inc
   include ..\include\dsound9.inc

   include ..\include\DD_util.inc
   include ..\Include\msvcrt.inc

   includelib kernel32.lib
   includelib user32.lib
   includelib ole32.lib
   includelib oleaut32.lib
   includelib winmm.lib
   includelib gdi32.lib
   includelib ..\lib\ddraw.lib
   includelib ..\lib\dsound.lib
   includelib ..\lib\msvcrt.lib

.const

SMILEY_ICON    equ 200
Pianokeys      equ 500
Pianomap       equ 501

.data

szClassName   db "DirectDraw Basic",0
szAppName     db "DirectDraw 2D AreaPic Example - by: Siekmanski",0
szDXInfo      db "DDRAW info",0

   align 4

szNoteString   dd offset Note_table
Note_table     db "---",0,"C-1",0,"C#1",0,"D-1",0,"D#1",0,"E-1",0,"F-1",0,"F#1",0,"G-1",0,"G#1",0,"A-1",0,"A#1",0,"B-1",0
               db "C-2",0,"C#2",0,"D-2",0,"D#2",0,"E-2",0,"F-2",0,"F#2",0,"G-2",0,"G#2",0,"A-2",0,"A#2",0,"B-2",0
               db "C-3",0,"C#3",0,"D-3",0,"D#3",0,"E-3",0,"F-3",0,"F#3",0,"G-3",0,"G#3",0,"A-3",0,"A#3",0,"B-3",0

Note_frequency dd 16726/4,17720/4,18789/4,19885/4,21117/4,22371/4,23704/4,25118/4,26612/4,28184/4,29828/4,31606/4
               dd 16726/2,17720/2,18789/2,19885/2,21117/2,22371/2,23704/2,25118/2,26612/2,28184/2,29828/2,31606/2
               dd 16726,17720,18789,19885,21117,22371,23704,25118,26612,28184,29828,31606

   align 4

g_pDD          LPDIRECTDRAW7 NULL
g_pDDSPrimary  LPDIRECTDRAWSURFACE7 NULL
g_pDDSBack     LPDIRECTDRAWSURFACE7 NULL
g_pDDClipper   LPDIRECTDRAWCLIPPER NULL     

pPianoMap      dd NULL

bProg_actief   dd TRUE

bWindowed      dd TRUE
bAutoInit      dd TRUE ; If TRUE standard desktop resolutions will be used
                       ; If FALSE our values below will be used......
dwWindow_Width  dd 640 ; our values
dwWindow_Height dd 480
dwWindow_Bits   dd 16

bMinimized    dd FALSE
bMaximized    dd FALSE

.data?

   align 4

hInst        dd ?
hWnd         dd ? 
WndProc_ptr  dd ?
WndProcF_ptr dd ?
Heap         dd ?

WindowRect   RECT <?>
rcPrimary    RECT <?>
rcBack       RECT <?>
rcPicture    RECT <?>
ddBack_bltfx DDBLTFX <?>
ddsd         DDSURFACEDESC2 <?>
ddscaps      DDSCAPS2 <?>

g_pPianoPic  DD_PICTURE <?>

dwRGBBitCount      dd ?    ; actual screenbits
dwRBitMask         dd ?
dwGBitMask         dd ?
dwBBitMask         dd ?
dwScreenWidth      dd ?    ; window changes
dwScreenHeight     dd ?

ScreenWidth        dd ?    ; Auto init actual values
ScreenHeight       dd ?
ScreenBits         dd ?
ScreenRefreshRate  dd ?

PicFactorX         real8 ? ; factor for picture_size ( areapicking )
PicFactorY         real8 ? ; factor for picture_size ( areapicking )
dwPianokeyNumber   dd ?

m_Cursor           POINT <?>

szString_buffer    db 256 dup (?)

.code

   include ..\common\DD_util.asm
   include ..\common\DS_util.asm

Calc_PicFactor proc
   fild    dwScreenWidth
   fidiv   g_pPianoPic.dwWidth
   fst     PicFactorX
   fstp    PicFactorY
   fild    g_pPianoPic.dwHeight
   fmul    PicFactorX
   fistp   rcPicture.bottom
   .if (bWindowed)
       fild    dwScreenHeight
       fidiv   rcBack.bottom
       fmul    PicFactorX
       fstp    PicFactorY
   .endif
   fld1
   fdiv    PicFactorX
   fstp    PicFactorX
   fld1
   fdiv    PicFactorY
   fstp    PicFactorY
   ret
Calc_PicFactor endp

Read_mouse proc uses esi hwnd:DWORD
   invoke  GetCursorPos,addr m_Cursor
   invoke  ScreenToClient,hwnd,addr m_Cursor
   fild    m_Cursor.x
   fmul    PicFactorX
   fistp   m_Cursor.x
   fild    m_Cursor.y
   fmul    PicFactorY
   fistp   m_Cursor.y

   mov     esi,pPianoMap
   mov     eax,m_Cursor.x
   cmp     eax,g_pPianoPic.dwWidth
   jb      CX_ok
   mov     eax,g_pPianoPic.dwWidth
   dec     eax
CX_ok:
   add     esi,eax
   mov     eax,m_Cursor.y
   cmp     eax,g_pPianoPic.dwHeight
   jb      CY_ok
   mov     eax,g_pPianoPic.dwHeight
   dec     eax
CY_ok:
   mul     g_pPianoPic.dwWidth
   add     esi,eax

   movzx   eax,byte ptr [esi]
   mov     dwPianokeyNumber,eax

   lea     esi,Note_table
   lea     esi,[esi+eax*4]
   mov     szNoteString,esi

   .if g_pDSWavSample != 0 && dwPianokeyNumber != 0
       mov     eax,dwPianokeyNumber
       lea     esi,Note_frequency
       mov     eax,[esi+eax*4-4]
       coinvoke    g_pDSWavSample,IDirectSoundBuffer8,SetFrequency,eax
       coinvoke    g_pDSWavSample,IDirectSoundBuffer8,SetCurrentPosition,0 
       coinvoke    g_pDSWavSample,IDirectSoundBuffer8,Play,0,0,0
   .endif

   ret
Read_mouse endp

Load_PianoMap proc uses esi edi
 local rsrcData:dword
 local fSize:dword

   invoke  FindResource,NULL,Pianomap,TEXT_("RT_RCDATA")
   test    eax,eax
   jz      Err_Find_Data 
   push    eax
   invoke  SizeofResource,NULL,eax
   mov     fSize,eax
   ALLOC_MEM   pPianoMap,eax
   test    eax,eax
   jz      Err_Find_Data
   pop     eax
   invoke  LoadResource,NULL,eax
   invoke  LockResource,eax
   mov     rsrcData,eax

   mov     esi,rsrcData
   mov     edi,pPianoMap
   mov     ecx,fSize
   cld
   rep     movsb

   invoke  FreeResource,rsrcData
   return  S_OK

Err_Find_Data:
   return  E_FAIL

Load_PianoMap endp

Load_AllPictures proc
   invoke   Load_Picture,Pianokeys,addr g_pPianoPic
   invoke   Calc_PicFactor
   ret
Load_AllPictures endp

StartDD proc
   invoke  Load_PianoMap
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("Load PianoMap FAILED"),offset szDXInfo,MB_OK
      return E_FAIL
   .endif

   invoke  DirectDrawCreateEx,NULL,addr g_pDD,GUID_(IID_IDirectDraw7),NULL
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("DirectDrawCreateEx FAILED"),offset szDXInfo,MB_OK
      return E_FAIL
   .endif

   return DD_OK
StartDD endp

StopDD proc
   SAFE_DELETE pPianoMap
   .if DD_font != 0
       invoke  DeleteObject,DD_font
   .endif
   SAFE_RELEASE g_pPianoPic.dwSurface
   SAFE_RELEASE g_pDDSBack
   SAFE_RELEASE g_pDDSPrimary
   SAFE_RELEASE g_pDD
   ret
StopDD endp

Window_changed proc hwnd:DWORD
   invoke  GetClientRect,hwnd,addr rcPrimary
   invoke  ClientToScreen,hwnd,addr rcPrimary.left
   invoke  ClientToScreen,hwnd,addr rcPrimary.right

   m2m     dwScreenWidth,rcPrimary.right
   mov     eax,rcPrimary.left
   sub     dwScreenWidth,eax
   m2m     dwScreenHeight,rcPrimary.bottom
   mov     eax,rcPrimary.top
   sub     dwScreenHeight,eax

   invoke  Calc_PicFactor
   ret
Window_changed endp


ToggleFullScreen proc hwnd:DWORD
   .if (!bWindowed)
       invoke   SetWindowLong,hwnd,GWL_EXSTYLE,WS_EX_CLIENTEDGE
       invoke   SetWindowLong,hwnd,GWL_STYLE,WS_OVERLAPPEDWINDOW
       invoke   SetWindowLong,hwnd,GWL_WNDPROC,WndProc_ptr
       mov      eax,WindowRect.right
       sub      eax,WindowRect.left
       mov      ecx,WindowRect.bottom
       sub      ecx,WindowRect.top
       invoke   SetWindowPos,hwnd,HWND_NOTOPMOST,WindowRect.left,WindowRect.top,eax,ecx,SWP_SHOWWINDOW
       mov      bWindowed,TRUE
       invoke   Window_changed,hwnd
   .else
       invoke   GetWindowRect,hwnd,addr WindowRect
       invoke   SetWindowLong,hwnd,GWL_EXSTYLE,WS_EX_TOPMOST
       invoke   SetWindowLong,hwnd,GWL_STYLE,WS_POPUP
       invoke   SetWindowLong,hwnd,GWL_WNDPROC,WndProcF_ptr
       mov      bWindowed,FALSE
   .endif
   ret
ToggleFullScreen endp


InitDD_Objects proc hwnd:DWORD 

   SAFE_RELEASE g_pDDSBack
   SAFE_RELEASE g_pDDSPrimary

   mov     rcBack.left,0
   mov     rcBack.top,0

   .if bWindowed == TRUE

       coinvoke g_pDD,IDirectDraw7,SetCooperativeLevel,hwnd,DDSCL_NORMAL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("SetCooperativeLevel FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       invoke  RtlZeroMemory,addr ddsd,sizeof DDSURFACEDESC2
       mov     ddsd.dwSize,sizeof DDSURFACEDESC2
       mov     ddsd.dwFlags,DDSD_CAPS
       mov     ddsd.ddsCaps.dwCaps,DDSCAPS_PRIMARYSURFACE

       coinvoke g_pDD,IDirectDraw7,CreateSurface,addr ddsd,addr g_pDDSPrimary, NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Create PrimarySurface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       invoke  RtlZeroMemory,addr ddsd,sizeof DDSURFACEDESC2
       mov     ddsd.dwSize,sizeof DDSURFACEDESC2
       mov     ddsd.dwFlags,DDSD_CAPS or DDSD_WIDTH or DDSD_HEIGHT
       mov     ddsd.ddsCaps.dwCaps,DDSCAPS_OFFSCREENPLAIN

       mov     eax,dwWindow_Width
       mov     rcBack.right,eax
       mov     ddsd.dwWidth,eax

       mov     eax,dwWindow_Height
       mov     rcBack.bottom,eax
       mov     ddsd.dwHeight,eax

       coinvoke g_pDD,IDirectDraw7,CreateSurface,addr ddsd,addr g_pDDSBack, NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Create BackSurface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDD,IDirectDraw7,CreateClipper,0,addr g_pDDClipper,NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Create Clipper FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDDClipper,IDirectDrawClipper,SetHWnd,0,hwnd
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Clipper SetHWnd FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDDSPrimary,IDirectDrawSurface7,SetClipper,g_pDDClipper
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("SetClipper FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       SAFE_RELEASE g_pDDClipper

   .elseif
       coinvoke g_pDD,IDirectDraw7,SetCooperativeLevel,hwnd,DDSCL_EXCLUSIVE or DDSCL_FULLSCREEN
       .if eax != DD_OK
           invoke ToggleFullScreen,hwnd
           invoke MessageBox,NULL,TEXT_("SetCooperativeLevel FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif


       .if bAutoInit == TRUE
           m2m     rcBack.right,ScreenWidth
           m2m     rcBack.bottom,ScreenHeight
           coinvoke g_pDD,IDirectDraw7,SetDisplayMode,ScreenWidth,ScreenHeight,ScreenBits,ScreenRefreshRate,0
       .else   
           m2m     rcBack.right,dwWindow_Width
           m2m     rcBack.bottom,dwWindow_Height
           coinvoke g_pDD,IDirectDraw7,SetDisplayMode,dwWindow_Width,dwWindow_Height,dwWindow_Bits,0,0
       .endif
           .if eax != DD_OK
               invoke ToggleFullScreen,hwnd
               invoke MessageBox,NULL,TEXT_("SetDisplayMode FAILED"),offset szDXInfo,MB_OK
               return E_FAIL
           .endif

       invoke  RtlZeroMemory,addr ddsd,sizeof DDSURFACEDESC2
       mov     ddsd.dwSize,sizeof DDSURFACEDESC2
       mov     ddsd.dwFlags,DDSD_CAPS or DDSD_BACKBUFFERCOUNT
       mov     ddsd.ddsCaps.dwCaps,DDSCAPS_PRIMARYSURFACE or DDSCAPS_FLIP or DDSCAPS_COMPLEX
       mov     ddsd.dwBackBufferCount,1
       coinvoke g_pDD,IDirectDraw7,CreateSurface,addr ddsd,addr g_pDDSPrimary, NULL
       .if eax != DD_OK
           invoke ToggleFullScreen,hwnd
           invoke MessageBox,NULL,TEXT_("Create PrimarySurface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       mov     ddscaps.dwCaps,DDSCAPS_BACKBUFFER
       coinvoke g_pDDSPrimary,IDirectDrawSurface7,GetAttachedSurface,addr ddscaps,addr g_pDDSBack
       .if eax != DD_OK
           invoke ToggleFullScreen,hwnd
           invoke MessageBox,NULL,TEXT_("Create BackBufferSurface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif


   .endif

   m2m     dwScreenWidth,rcBack.right
   m2m     dwScreenHeight,rcBack.bottom

   m2m     rcPicture.left,rcBack.left  ; make a copy of the backbufferRect
   m2m     rcPicture.top,rcBack.top
   m2m     rcPicture.right,rcBack.right
   m2m     rcPicture.bottom,rcBack.bottom

   invoke  RtlZeroMemory,addr ddBack_bltfx,sizeof DDBLTFX
   mov     ddBack_bltfx.dwSize,sizeof DDBLTFX
   mov     ddBack_bltfx.dwFillColor,00000000h    ;// vulkleur = zwart (0)

   coinvoke g_pDD,IDirectDraw7,GetDisplayMode,addr ddsd
   .if eax != DD_OK
       .if bWindowed == FALSE
           invoke ToggleFullScreen,hwnd
       .endif
       invoke MessageBox,NULL,TEXT_("GetDisplayMode FAILED"),offset szDXInfo,MB_OK
      return E_FAIL
   .endif

   mov     eax,ddsd.ddpfPixelFormat.dwRGBBitCount
   mov     dwRGBBitCount,eax
   mov     eax,ddsd.ddpfPixelFormat.dwRBitMask
   mov     dwRBitMask,eax
   mov     ecx,ddsd.ddpfPixelFormat.dwGBitMask
   mov     dwGBitMask,ecx
   add     eax,ecx
   mov     ecx,ddsd.ddpfPixelFormat.dwBBitMask
   mov     dwBBitMask,ecx
   add     eax,ecx
   .if eax == 32767
       mov dwRGBBitCount,15
   .endif

   invoke  Load_AllPictures

   return DD_OK
InitDD_Objects endp

RenderDD proc hwnd:DWORD
   coinvoke g_pDDSPrimary,IDirectDrawSurface7,IsLost
   .if eax == DDERR_SURFACELOST
       coinvoke g_pDD,IDirectDraw7,RestoreAllSurfaces
       .if eax != DD_OK
           invoke  InitDD_Objects,hwnd
       .elseif eax == DD_OK
           invoke  Load_AllPictures
       .endif
   .endif

   .if bWindowed == TRUE

       coinvoke g_pDD,IDirectDraw7,WaitForVerticalBlank,DDWAITVB_BLOCKBEGIN,NULL 
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("WaitForVerticalBlank FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

       coinvoke g_pDDSPrimary,IDirectDrawSurface7,Blt,addr rcPrimary,g_pDDSBack,NULL,DDBLT_WAIT,NULL
       .if eax != DD_OK
           invoke MessageBox,NULL,TEXT_("Blit to Primary Surface FAILED"),offset szDXInfo,MB_OK
           return E_FAIL
       .endif

   .elseif
       coinvoke g_pDDSPrimary,IDirectDrawSurface7,Flip,0,DDFLIP_WAIT
   .endif

;  veeg backbuffer leeg
   coinvoke g_pDDSBack,IDirectDrawSurface7,Blt,NULL,NULL,NULL,DDBLT_COLORFILL or DDBLT_WAIT,addr ddBack_bltfx

   coinvoke g_pDDSBack,IDirectDrawSurface7,Blt,addr rcPicture,g_pPianoPic.dwSurface,NULL,DDBLT_WAIT,NULL
   .if eax != DD_OK
       invoke MessageBox,NULL,TEXT_("Blit Picture FAILED"),offset szDXInfo,MB_OK
      return E_FAIL
   .endif

   invoke  sprintf,addr szString_buffer,TEXT_("Screen resolution: %d x %d"),dwScreenWidth,dwScreenHeight
   invoke  Print_Text,10,270,RGB(255,0,0),addr szString_buffer

   invoke  sprintf,addr szString_buffer,TEXT_("PicFactorX: %2.6f     PicFactorY: %2.6f "),PicFactorX,PicFactorY
   invoke  Print_Text,10,300,RGB(255,0,0),addr szString_buffer

   invoke  sprintf,addr szString_buffer,TEXT_("CursorX: %4d CursorY: %4d "),m_Cursor.x,m_Cursor.y
   invoke  Print_Text,10,330,RGB(255,0,0),addr szString_buffer

   invoke  sprintf,addr szString_buffer,TEXT_("Pianokey number: %d -->  Note: %s"),dwPianokeyNumber,szNoteString
   invoke  Print_Text,10,390,RGB(255,0,0),addr szString_buffer

   invoke  Print_Text,10,420,RGB(0,127,0),TEXT_("Window can be resized, F1 to toggle fullscreen")

   return DD_OK
RenderDD endp


WndProc proc hwnd:DWORD,wMsg:DWORD,wParam:DWORD,lParam:DWORD
   .if wMsg == WM_DESTROY
       invoke   PostQuitMessage,NULL
       return   0

   .elseif wMsg == WM_SIZE   ; check if window size has changed
       .if wParam == SIZE_MINIMIZED
           mov      bProg_actief,FALSE
           mov      bMinimized,TRUE
           mov      bMaximized,FALSE
       .elseif wParam == SIZE_MAXIMIZED
           invoke   Window_changed,hwnd
           mov      bMinimized,FALSE
           mov      bMaximized,TRUE
       .elseif wParam == SIZE_RESTORED
           .if (bMaximized)
               invoke   Window_changed,hwnd
               mov      bMaximized,FALSE
           .elseif (bMinimized)
               mov      bProg_actief,TRUE
               mov      bMinimized,FALSE
           .endif
       .endif
       return   0

   .elseif wMsg == WM_EXITSIZEMOVE
           invoke   Window_changed,hwnd
       return   0

   .elseif wMsg == WM_PAINT
       invoke   ValidateRect,hwnd,NULL
       return   0

   .elseif wMsg == WM_KEYDOWN
       .if wParam == VK_ESCAPE
           invoke   PostQuitMessage,WM_QUIT
           return   0
       .elseif wParam == VK_F1
           invoke   ToggleFullScreen,hwnd
           invoke   InitDD_Objects,hwnd
            if_FAILED
               invoke   PostQuitMessage,WM_QUIT
            .endif
       .endif
       return   0

    .elseif wMsg == WM_LBUTTONUP
       invoke   Read_mouse,hwnd
       return   0

   .else
       invoke   DefWindowProc,hwnd,wMsg,wParam,lParam
       ret
   .endif
WndProc endp

WndProcfullscreen proc hwnd:DWORD,wMsg:DWORD,wParam:DWORD,lParam:DWORD
   .if wMsg == WM_DESTROY
       invoke   PostQuitMessage,NULL
       return   0

;   .elseif wMsg == WM_SETCURSOR
;       invoke   SetCursor,NULL ; turn off cursor               
;       return   TRUE

    .elseif wMsg == WM_LBUTTONUP
       invoke   Read_mouse,hwnd
       return   0


   .elseif wMsg == WM_KEYDOWN
       .if wParam == VK_ESCAPE
           invoke   PostQuitMessage,WM_QUIT
           return   0
       .elseif wParam == VK_F1
           invoke   ToggleFullScreen,hwnd
           invoke   InitDD_Objects,hwnd
           invoke   Window_changed,hwnd
       .endif
       return   0

   .else
       invoke   DefWindowProc,hwnd,wMsg,wParam,lParam
       ret
   .endif
WndProcfullscreen endp


WinMain proc hinst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD
 LOCAL wc:WNDCLASSEX
 LOCAL msg:MSG
 LOCAL hdc:HDC

   mov      wc.cbSize,sizeof WNDCLASSEX
   mov      wc.style,CS_HREDRAW or CS_VREDRAW or CS_OWNDC
   mov      eax,offset WndProcfullscreen
   mov      WndProcF_ptr,eax
   mov      eax,offset WndProc
   mov      WndProc_ptr,eax
   mov      wc.lpfnWndProc,eax
   mov      wc.cbClsExtra,NULL
   mov      wc.cbWndExtra,NULL
   mov      eax,hInst
   mov      wc.hInstance,eax
   invoke   GetStockObject,BLACK_BRUSH
   mov      wc.hbrBackground,eax
   mov      wc.lpszMenuName,NULL
   mov      wc.lpszClassName,offset szClassName
   invoke   LoadIcon,hInst,SMILEY_ICON
   mov      wc.hIcon,eax
   mov      wc.hIconSm,eax
   invoke   LoadCursor,NULL,IDC_ARROW
   mov      wc.hCursor,eax
   invoke   RegisterClassEx,addr wc

   invoke   SetRect,addr WindowRect,0,0,dwWindow_Width,dwWindow_Height
   invoke   AdjustWindowRectEx,addr WindowRect,WS_OVERLAPPEDWINDOW,FALSE,WS_EX_CLIENTEDGE

   invoke   GetDC,NULL
   mov      hdc,eax

   mov      eax,WindowRect.left
   sub      WindowRect.right, eax
   mov      eax,WindowRect.top
   sub      WindowRect.bottom, eax
   invoke   GetDeviceCaps,hdc,HORZRES
   mov      ScreenWidth,eax
   sub      eax,WindowRect.right
   shr      eax,1
   mov      WindowRect.left,eax
   invoke   GetDeviceCaps,hdc,VERTRES
   mov      ScreenHeight,eax
   sub      eax,WindowRect.bottom
   shr      eax,1
   mov      WindowRect.top,eax
   invoke   GetDeviceCaps,hdc,BITSPIXEL
   mov      ScreenBits,eax
   invoke   GetDeviceCaps,hdc,VREFRESH
   mov      ScreenRefreshRate,eax

   invoke   DeleteDC,hdc

   invoke   GetDesktopWindow
   invoke   CreateWindowEx,WS_EX_CLIENTEDGE,addr szClassName,addr szAppName,WS_OVERLAPPEDWINDOW, \
                           WindowRect.left,WindowRect.top,WindowRect.right,WindowRect.bottom,eax,NULL,hInst,NULL
   mov      hWnd,eax


   invoke   Window_changed,eax

   .if (!bWindowed)
       invoke   GetWindowRect,hWnd,addr WindowRect
       invoke   SetWindowLong,hWnd,GWL_EXSTYLE,WS_EX_TOPMOST
       invoke   SetWindowLong,hWnd,GWL_STYLE,WS_POPUP
       invoke   SetWindowLong,hWnd,GWL_WNDPROC,WndProcF_ptr
   .endif

   invoke   UpdateWindow,hWnd
   invoke   ShowWindow,hWnd,SW_SHOWNORMAL

   invoke   StartDD
   if_FAILED
      jmp   EndDD
   .endif

   invoke   InitDD_Objects,hWnd 
   if_FAILED
      SAFE_RELEASE g_pDD
      jmp   EndDD
   .endif

   invoke   Init_DDFont,TEXT_("Comic Sans MS"),16

   invoke   StartDSound,hWnd,2,44100,16  
   .if (eax != DS_OK)
      jmp   EndDD
   .endif

   invoke  Load_wav,TEXT_("..\media\piano3.wav"),addr g_pDSWavSample
           .if (g_pDSWavSample != 0)
               coinvoke    g_pDSWavSample,IDirectSoundBuffer8,SetVolume,DSBVOLUME_MAX 
               coinvoke    g_pDSWavSample,IDirectSoundBuffer8,SetCurrentPosition,0 
               coinvoke    g_pDSWavSample,IDirectSoundBuffer8,Play,0,0,0
           .endif

   invoke   RtlZeroMemory,addr msg,sizeof msg

   .while TRUE
      invoke PeekMessage,addr msg,NULL,0,0,PM_REMOVE
      .if eax != 0
          .if msg.message == WM_QUIT
              invoke PostQuitMessage,msg.wParam
              .break
          .else
              invoke TranslateMessage,addr msg
              invoke DispatchMessage,addr msg
          .endif 
      .else
          invoke   RenderDD,hWnd                   
      .endif
   .endw

EndDD:
   invoke   StopDSound
   invoke   StopDD 
   invoke   CoUninitialize
   invoke   UnregisterClass,addr szClassName,wc.hInstance

   mov      eax,msg.wParam
   ret
WinMain endp


start:
   invoke   CoInitialize,NULL

   invoke   GetModuleHandle,NULL
   mov      hInst,eax

   invoke   GetProcessHeap
   mov      Heap,eax

   invoke   WinMain,hInst,NULL,NULL,SW_SHOWDEFAULT
   invoke   ExitProcess,eax
end start
